<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `src/hlo_json/prune/param_priority.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>param_priority.rs - source</title><link rel="stylesheet" type="text/css" href="../../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../../../ayu.css" disabled ><script id="default-settings"></script><script src="../../../../storage.js"></script><noscript><link rel="stylesheet" href="../../../../noscript.css"></noscript><link rel="icon" type="image/svg+xml" href="../../../../favicon.svg">
<link rel="alternate icon" type="image/png" href="../../../../favicon-16x16.png">
<link rel="alternate icon" type="image/png" href="../../../../favicon-32x32.png"><style type="text/css">#crate-search{background-image:url("../../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 8]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu">&#9776;</div><a href='../../../../HPGO/index.html'><div class='logo-container rust-logo'><img src='../../../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu"><img src="../../../../brush.svg" width="18" alt="Pick another theme!"></button><div id="theme-choices" role="menu"></div></div><script src="../../../../theme.js"></script><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" class="help-button">?</button>
                <a id="settings-menu" href="../../../../settings.html"><img src="../../../../wheel.svg" width="18" alt="Change settings"></a></div></form></nav><section id="main" class="content"><pre class="line-numbers"><span id="1"> 1</span>
<span id="2"> 2</span>
<span id="3"> 3</span>
<span id="4"> 4</span>
<span id="5"> 5</span>
<span id="6"> 6</span>
<span id="7"> 7</span>
<span id="8"> 8</span>
<span id="9"> 9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
</pre><div class="example-wrap"><pre class="rust ">
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">hlo_json</span>::<span class="ident">hlo_ast</span>::<span class="ident">Param</span>;
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">hlo_json</span>::<span class="ident">propagate</span>::<span class="ident">ast_propagate</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">rayon</span>::<span class="ident">prelude</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">collections</span>::<span class="ident">HashMap</span>;
<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">time</span>::<span class="ident">Instant</span>;

<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">prioritized_params</span>(<span class="ident">ctx</span>: <span class="kw-2">&amp;</span><span class="ident">Context</span>, <span class="ident">func_id</span>: <span class="ident">usize</span>, <span class="ident">params</span>: <span class="kw-2">&amp;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Param</span><span class="op">&gt;</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Param</span><span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="ident">now</span> <span class="op">=</span> <span class="ident">Instant</span>::<span class="ident">now</span>();
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">p_values</span>: <span class="ident">Vec</span><span class="op">&lt;</span>(<span class="ident">usize</span>, <span class="ident">i32</span>)<span class="op">&gt;</span> <span class="op">=</span> <span class="ident">params</span>
        .<span class="ident">par_iter</span>()
        .<span class="ident">enumerate</span>()
        .<span class="ident">map</span>(<span class="op">|</span>(<span class="ident">i</span>, <span class="ident">p</span>)<span class="op">|</span> {
            <span class="kw">let</span> <span class="ident">bfs_result</span> <span class="op">=</span> <span class="ident">ctx</span>
                .<span class="ident">propagate_bfs</span>(<span class="ident">func_id</span>, <span class="kw-2">&amp;</span><span class="ident">p</span>.<span class="ident">name</span>, <span class="op">-</span><span class="number">1</span>, <span class="kw-2">&amp;</span><span class="ident">HashMap</span>::<span class="ident">new</span>(), <span class="bool-val">false</span>)
                .<span class="ident">unwrap</span>();
            <span class="kw">if</span> <span class="ident">bfs_result</span>.<span class="ident">is_none</span>() {
                <span class="kw">return</span> (<span class="ident">i</span>, <span class="op">-</span><span class="number">1</span>);
            } <span class="kw">else</span> {
                <span class="kw">return</span> (<span class="ident">i</span>, <span class="ident">bfs_result</span>.<span class="ident">unwrap</span>().<span class="ident">len</span>() <span class="kw">as</span> <span class="ident">i32</span>);
            }
        })
        .<span class="ident">collect</span>();

    <span class="comment">// sort p_values in decreasing order</span>
    <span class="ident">p_values</span>.<span class="ident">par_sort_unstable_by_key</span>(<span class="op">|</span><span class="ident">x</span><span class="op">|</span> <span class="ident">x</span>.<span class="number">1</span>);
    <span class="ident">p_values</span>.<span class="ident">reverse</span>();

    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">p_vec</span> <span class="op">=</span> <span class="macro">vec</span><span class="macro">!</span>[];
    <span class="kw">for</span> <span class="ident">p</span> <span class="kw">in</span> <span class="ident">p_values</span> {
        <span class="ident">p_vec</span>.<span class="ident">push</span>(<span class="ident">params</span>[<span class="ident">p</span>.<span class="number">0</span>].<span class="ident">clone</span>());
    }

    <span class="macro">println</span><span class="macro">!</span>(
        <span class="string">&quot;[pruning]\t Reorder Input Params... {}ms&quot;</span>,
        <span class="ident">now</span>.<span class="ident">elapsed</span>().<span class="ident">as_millis</span>()
    );

    <span class="ident">p_vec</span>
}
</pre></div>
</section><section id="search" class="content hidden"></section><section class="footer"></section><script>window.rootPath = "../../../../";window.currentCrate = "HPGO";</script><script src="../../../../main.js"></script><script src="../../../../source-script.js"></script><script src="../../../../source-files.js"></script><script defer src="../../../../search-index.js"></script></body></html>